//  2009.11.29 ˂t@Cǂݍ݂̂ƂɁAŝ͎Ă

unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Buttons, ExtCtrls;

type
  TMainForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ListBox1: TListBox;
    Panel1: TPanel;
    MemSafe: TMemo;
    MemQuality: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
  private
    FAbove: TStringList;
    FMiddle: TStringList;
    FBelow: TStringList;
    procedure LoadPartsA(const AFolder: String);
    procedure LoadPartsQ(const AFolder: String);
  public
    { Public 錾 }
  end;

var
  MainForm: TMainForm;

implementation

uses
    Info, mt19937ar;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  N
procedure TMainForm.FormCreate(Sender: TObject);
var
    LFileName: String;
begin
    SetFormCaption(Self);

    FAbove := TStringList.Create();
    FMiddle := TStringList.Create();
    FBelow := TStringList.Create();

    LFileName := ChangeFileExt(ParamStr(0), 'Sۊǌ.txt');
    if (FileExists(LFileName)) then
    begin
        MemSafe.Lines.LoadFromFile(LFileName);
        MemSafe.Text := Trim(MemSafe.Text);
    end;
    LFileName := ChangeFileExt(ParamStr(0), 'iۊǌ.txt');
    if (FileExists(LFileName)) then
    begin
        MemQuality.Lines.LoadFromFile(LFileName);
        MemQuality.Text := Trim(MemQuality.Text);
    end;

    //  W쐬
    BitBtn1Click(BitBtn1);
end;

//-----------------------------------------------------------------------------
//  I
procedure TMainForm.FormDestroy(Sender: TObject);
var
    LFileName: String;
begin
    LFileName := ChangeFileExt(ParamStr(0), 'Sۊǌ.txt');
    MemSafe.Lines.SaveToFile(LFileName);
    LFileName := ChangeFileExt(ParamStr(0), 'iۊǌ.txt');
    MemQuality.Lines.SaveToFile(LFileName);

    FAbove.Free();
    FMiddle.Free();
    FBelow.Free();
end;

//-----------------------------------------------------------------------------
//  Sf[^ǂݍ
procedure TMainForm.LoadPartsA(const AFolder: String);
var
    LFileName: String;
    i: Integer;
begin
    LFileName := IncludeTrailingPathDelimiter(AFolder) + 'S.txt';
    if (FileExists(LFileName)) then
    begin
        FAbove.LoadFromFile(LFileName);
        for i := FAbove.Count - 1 downto 0 do
        begin
            if (Trim(FAbove[i]) = '') then FAbove.Delete(i);
        end;
    end;
    LFileName := IncludeTrailingPathDelimiter(AFolder) + 'S.txt';
    if (FileExists(LFileName)) then
    begin
        FMiddle.LoadFromFile(LFileName);
        for i := FMiddle.Count - 1 downto 0 do
        begin
            if (Trim(FMiddle[i]) = '') then FMiddle.Delete(i);
        end;
    end;
    LFileName := IncludeTrailingPathDelimiter(AFolder) + 'S.txt';
    if (FileExists(LFileName)) then
    begin
        FBelow.LoadFromFile(LFileName);
        for i := FBelow.Count - 1 downto 0 do
        begin
            if (Trim(FBelow[i]) = '') then FBelow.Delete(i);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  if[^ǂݍ
procedure TMainForm.LoadPartsQ(const AFolder: String);
var
    LFileName: String;
    i: Integer;
begin
    LFileName := IncludeTrailingPathDelimiter(AFolder) + 'i.txt';
    if (FileExists(LFileName)) then
    begin
        FAbove.LoadFromFile(LFileName);
        for i := FAbove.Count - 1 downto 0 do
        begin
            if (Trim(FAbove[i]) = '') then FAbove.Delete(i);
        end;
    end;
    LFileName := IncludeTrailingPathDelimiter(AFolder) + 'i.txt';
    if (FileExists(LFileName)) then
    begin
        FMiddle.LoadFromFile(LFileName);
        for i := FMiddle.Count - 1 downto 0 do
        begin
            if (Trim(FMiddle[i]) = '') then FMiddle.Delete(i);
        end;
    end;
    LFileName := IncludeTrailingPathDelimiter(AFolder) + 'i.txt';
    if (FileExists(LFileName)) then
    begin
        FBelow.LoadFromFile(LFileName);
        for i := FBelow.Count - 1 downto 0 do
        begin
            if (Trim(FBelow[i]) = '') then FBelow.Delete(i);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  o[W
procedure TMainForm.BitBtn2Click(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
//  ۊǌɂɃRs[
procedure TMainForm.ListBox1DblClick(Sender: TObject);
var
    LIndex: Integer;
    LLine: String;
    LMemo: TMemo;
begin
    LIndex := ListBox1.ItemIndex;
    if (LIndex <> -1) then
    begin
        LLine := ListBox1.Items[ListBox1.ItemIndex];
    end;
    if (LLine <> '') then
    begin
        if (PageControl1.ActivePageIndex = 0) then
        begin
            LMemo := MemSafe;
        end
        else
        begin
            LMemo := MemQuality;
        end;
        LIndex := LMemo.Lines.IndexOf(LLine);
        if (LIndex = -1) then
        begin
            LMemo.Lines.Add(LLine);
        end
        else
        begin
            LMemo.Lines.Delete(LIndex);
            LMemo.Lines.Add(LLine);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  W쐬
procedure TMainForm.BitBtn1Click(Sender: TObject);
var
    i: Integer;
    LIndex: Integer;
    LLine: String;
    LAbobe, LMiddle, LBelow: String;
begin
    //  ˂ǂݍ
    if (PageControl1.ActivePageIndex = 0) then
    begin
        LoadPartsA(ExtractFilePath(ParamStr(0)));
    end
    else
    begin
        LoadPartsQ(ExtractFilePath(ParamStr(0)));
    end;

    //  
    InitGenRand(GetTickCount());

    //  XgNA
    ListBox1.Items.Clear();

    //  `FbN
    if (FAbove.Count = 0) then Exit;
    if (FMiddle.Count = 0) then Exit;
    if (FBelow.Count = 0) then Exit;

    //  쐬
    for i := 0 to 4 do
    begin
        //  
        LIndex := GenRandInt31() mod FAbove.Count;
        if (LIndex <= FAbove.Count - 1) then
        begin
            LAbobe := FAbove[LIndex];
        end;
        //  
        LIndex := GenRandInt31() mod FMiddle.Count;
        if (LIndex <= FMiddle.Count - 1) then
        begin
            LMiddle := FMiddle[LIndex];
        end;
        //  
        LIndex := GenRandInt31() mod FBelow.Count;
        if (LIndex <= FBelow.Count - 1) then
        begin
            LBelow := FBelow[LIndex];
        end;
        //  
        LLine := Format('%s %s %s', [LAbobe, LMiddle, LBelow]);
        //  o
        if (LLine <> '') then
        begin
            ListBox1.Items.Add(LLine);
        end;
    end;
end;

end.
